<template>
  <v-card class="mx-auto" max-width="100%">
    <confirmation-modal :is-open="openModal" :modal-text="modalText" @confirm="confirmRegister" @cancel="cancelRegister" />
    <v-card-subtitle class="pb-0">
      <image-field v-model="patient.user.image" :validation="imageValidation" :url-image="patient.profileImage" />
      <v-divider class="mb-4" />
      <v-form ref="form" lazy-validation>
        <v-container fluid>
          <select-field v-model="patient.user.typeDocument" :items="typesDocument" field-name="Tipo de documento" @selectChange="changeSELECT" />
          <register-field-validation
            v-if="patient.user.typeDocument==='DNI'"
            v-model="patient.user.document"
            field-name="DNI"
            :validation="DNIValidation"
            place-holder="Ingrese DNI"
            @inputChange="changeDNI"
          />
          <register-field-validation
            v-if="patient.user.typeDocument==='CARNET EXTRANJERÍA'"
            v-model="patient.user.document"
            field-name="Carnet de extranjería"
            :validation="carnetValidation"
            place-holder="Ingrese Carnet de extranjería"
            @inputChange="changeCarnetOrPassport"
          />
          <register-field-validation
            v-if="patient.user.typeDocument==='PASAPORTE'"
            v-model="patient.user.document"
            field-name="Pasaporte"
            :validation="passportValidation"
            place-holder="Ingrese Pasaporte"
            @inputChange="changeCarnetOrPassport"
          />
          <register-field-validation v-model="patient.user.name" :disabled="disabled_user_info" field-name="Nombre" :validation="nameValidation" place-holder="Ingrese Nombre" />
          <register-field-validation v-model="patient.user.fatherLastname" :disabled="disabled_user_info" field-name="Apellido Paterno" :validation="fatherLastnameValidation" place-holder="Ingrese Apellido Paterno" />
          <register-field-validation v-model="patient.user.motherLastname" :disabled="disabled_user_info" field-name="Apellido Materno " :validation="motherLastNameValidation" place-holder="Ingrese Apellido Materno" />
          <register-field-validation v-model="patient.email" field-name="Correo Electrónico" :validation="emailValidation" place-holder="Ingrese Correo Electónico" />
          <register-field-validation v-model="patient.phoneNumber" field-name="Número de Celular" :validation="phoneValidation" place-holder="Ingrese un Número de Celular" />
          <register-field-validation v-model="patient.address" field-name="Domicilio" place-holder="Ingrese Domicilio" />
          <picker-field v-model="patient.user.birthdate" field-name="Fecha Nacimiento" :max="$config.birthdateValidation"/>
        </v-container>
      </v-form>
    </v-card-subtitle>
     <buttons-register-form @saveUser="handleRegisterPatient" @cancel="cancelForm" />
    <br>
    <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
      {{ snackBar.text }}
      <template #action="{ attrs }">
        <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
          <v-icon>mdi-window-close</v-icon>
        </v-btn>
      </template>
    </v-snackbar>
  </v-card>
</template>

<script>
import { mapActions, mapGetters, mapState } from 'vuex';
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import PickerField from '~/components/InputField/PickerField';
import SelectField from '~/components/InputField/SelectField.vue';
import ButtonsRegisterForm from '~/components/InputField/ButtonsRegisterForm.vue';
import imageField from '~/components/InputField/ImageField';
import ConfirmationModal from '~/components/register/confirmationModal';
import {
  DNIRules,
  nameRules,
  fatherLastnameRules,
  motherLastnameRules,
  emailRules,
  imageFileRules,
  phoneRules, carnetRules, passportRules,
} from '~/helpers/validation';
import { imageDefault } from '~/helpers/constants';

export default {
  name: 'EditarPaciente',
  components: { RegisterFieldValidation, PickerField, ButtonsRegisterForm, imageField, ConfirmationModal, SelectField },
  data: () => ({
    typeDocumentSelected: 'DNI',
    typesDocument: ['CARNET EXTRANJERÍA', 'DNI', 'PASAPORTE'],
    disabled_user_info: true,
    disabled_patient_info: true,
    isValidForm: false,
    DNIValidation: DNIRules,
    carnetValidation: carnetRules,
    passportValidation: passportRules,
    nameValidation: nameRules,
    fatherLastnameValidation: fatherLastnameRules,
    motherLastNameValidation: motherLastnameRules,
    emailValidation: emailRules,
    phoneValidation: phoneRules,
    imageValidation: imageFileRules,
    openModal: false,
    modalText: '¿Estás seguro que deseas guardar los cambios?',
    snackBar: {
      show: false,
      color: '',
      text: '',
    },
    patient: {
      user: {
        profileImage: null,
        image: null,
        document: '',
        typeDocument: '',
        name: '',
        fatherLastname: '',
        motherLastname: '',
        phoneNumber: '',
        address: '',
        email: '',
        id: null,
        uuid: null,
        birthdate: new Date().toISOString().substr(0, 10),
      },
      profileImage: null,
      phoneNumber: '',
      address: '',
      email: '',
    },
  }),

  computed: {
    ...mapState({
      checkedPatient: state => state.clientcompany.patient.checkedPatient,
    }),
    ...mapGetters({
      storedPatient: 'clientcompany/patient/getOnePatient',
    }),
  },
  async mounted() {
    this.clearForm();
    await this.getAPatient();
  },
  methods: {
    ...mapActions({
      savePatient: 'clientcompany/patient/editPatient',
      getPatients: 'clientcompany/patient/getPatients',
      getPatient: 'clientcompany/patient/getPatient',
      checkedInformationPatient: 'clientcompany/patient/checkedInformationPatient',
    }),
    async confirmRegister() {
      await this.register(this.patient);
      await this.$router.push('/pacientes');
    },
    async getAPatient() {
      await this.getPatient({ uuid: this.$route.params.id });
      this.patient = JSON.parse(JSON.stringify(this.storedPatient));
      if (this.patient.user.typeDocument === 'CARNET') {
        this.patient.user.typeDocument = 'CARNET EXTRANJERÍA';
      }
    },
    cancelRegister() {
      this.openModal = false;
    },

    handleRegisterPatient() {
      if (this.$refs.form.validate()) {
        this.openModal = true;
      }
    },
    async register(patient) {
      const formData = new FormData();
      if (this.patient.user.image === undefined) {
        fetch(imageDefault)
          .then(function (response) {
            return response.blob();
          })
          .then(function (blob) {
            formData.append('multipartFile', blob);
            // this.patient.user.profileImage = blob;
          });
      } else {
        formData.append('multipartFile', this.patient.user.image);
      }
      formData.append('id', this.patient.id);
      if (this.patient.user.typeDocument === 'CARNET EXTRANJERÍA') {
        formData.append('typeDocument', 'CARNET');
      } else {
        formData.append('typeDocument', this.patient.user.typeDocument);
      }
      formData.append('profileImage', patient.profileImage);
      formData.append('document', patient.user.document);
      formData.append('name', this.patient.user.name);
      formData.append('fatherLastname', this.patient.user.fatherLastname);
      formData.append('motherLastname', this.patient.user.motherLastname);
      formData.append('email', this.patient.email);
      formData.append('phoneNumber', this.patient.phoneNumber);
      formData.append('address', this.patient.address);
      formData.append('birthdate', this.patient.user.birthdate);
      await this.savePatient({ patient: formData });
    },
    cancelForm() {
      this.clearForm();
      this.$router.push('/pacientes');
    },
    changeSELECT() {
      this.patient.user.document = '';
      // this.clearForm();
    },
    async changeDNI(valid) {
      this.disabled_user_info = true;
      this.valid = valid;
      if (valid) {
        const checkedPatient = await this.checkedInformationPatient(this.patient.user.document);
        this.checkedUser(checkedPatient.data, this.typeDocumentSelected);
      }
    },
    async changeCarnetOrPassport(valid) {
      this.valid = valid;
      if (valid) {
        this.disabled_patient_info = false;
        const checkedpatient = await this.checkedInformationPatient(this.patient.user.document);
        this.checkedUserWithCarnetOrPassport(checkedpatient.data, this.typeDocumentSelected);
      } else {
        this.disabled_user_info = true;
        this.disabled_patient_info = true;
      }
    },
    checkedUser(patient, typeDocumentSelected) {
      this.snackBar.color = 'primary';
      this.clearForm();
      /* If a user with this DNI doesn't exist */
      if (patient.user == null && patient.userApi == null) {
        this.setNackBar('El documento ' + typeDocumentSelected + ' no existe', 'error', true);
      }
      /* If user tries to edit the document with the value of a registered document (in database) */
      if (this.valid && patient.user != null && this.storedPatient.user.uuid !== patient.user.uuid) {
        /* If a user with this document exist. And this user is NOT a patient (registered as specialist or admin) */
        if (!patient.isPatient) {
          this.ifUserRegisteredIsNotpatient(patient, typeDocumentSelected);
        } else if (patient.isPatient) {
          /* If a user with this document exist AND this user is a patient */
          this.ifUserRegisteredIsPatient(patient, typeDocumentSelected);
        } else {
          this.snackBar.color = 'error';
          this.snackBar.text = 'El documento ya se encuentra asociado a otro usuario.';
          this.snackBar.show = true;
        }
      } else {
        /* If user tries to edit the document with the value of an unregistered document (in dabtabase) */
        this.patient.user.name = patient.userApi.nombres;
        this.patient.user.fatherLastname = patient.userApi.apellidoPaterno;
        this.patient.user.motherLastname = patient.userApi.apellidoMaterno;
      }
    },

    checkedUserWithCarnetOrPassport(patient, typeDocumentSelected) {
      this.clearForm();
      this.disabled_user_info = true;
      this.disabled_patient_info = true;

      /* If a user with this DNI is not registered in BD */
      if (this.valid && patient.user == null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.disabled_user_info = false;
        this.disabled_patient_info = false;
      }
      /* If a user with this DNI exist. And this user is NOT a patient */
      if (this.valid && patient.user != null && !patient.isPatient) {
        this.ifUserRegisteredIsNotpatient(patient, typeDocumentSelected);
      }
      /* If a user with this DNI exist AND this user is a patient */
      if (this.valid && patient.user != null && patient.isPatient) {
        this.ifUserRegisteredIsPatient(patient, typeDocumentSelected);
      }
    },
    ifUserRegisteredIsNotpatient(patient, typeDocumentSelected) {
      this.setNackBar(typeDocumentSelected + ' vinculado a un usuario. Complete los campos restantes.', 'primary', true);
      this.patient.user = patient.user;
      this.disabled_patient_info = false;
    },
    ifUserRegisteredIsPatient(patient, typeDocumentSelected) {
      this.setNackBar('El paciente ya se encuentra registrado con el documento ' + typeDocumentSelected, 'error', true);
      this.patient.user = patient.user;
    },
    setNackBar(text, color, show) {
      this.snackBar.text = text;
      this.snackBar.show = show;
      this.snackBar.color = color;
    },
    clearForm() {
      this.patient.user.name = '';
      this.patient.user.fatherLastname = '';
      this.patient.user.motherLastname = '';
      // this.patient.user.email = '';
      // this.patient.user.phoneNumber = '';
      // this.patient.user.birthdate = '';
      // this.patient.address = '';
    },
  },
};
</script>
